/* This file will be pre-processed by cpp */

#include "blake_cst.pp"

#define NODIFF : --------------------------------

#define STR(x) #x
#define M(i) m##i
#define S(i) s##i

#define REPEAT16(X,t)                           \
	X( 0,t) X( 1,t) X( 2,t) X( 3,t)		\
	X( 4,t) X( 5,t) X( 6,t) X( 7,t)		\
	X( 8,t) X( 9,t) X(10,t) X(11,t)		\
	X(12,t) X(13,t) X(14,t) X(15,t)

#define XXMSG(x,y) @hidden "m+c" tmp_m = m##x ^ c##y;
#define XMSG(x,y) XXMSG(x,y)
#define MSG0(r,i) XMSG(SIGMA(r,T0(i)),SIGMA(r,T1(i)))
#define MSG1(r,i) XMSG(SIGMA(r,T1(i)),SIGMA(r,T0(i)))


#define TMP_MSG_VARS(i,x) @state m##i x;

#define MSG_VARS(x)                              \
        @vbox;                                   \
        REPEAT16(TMP_MSG_VARS,x)                 \
        @end;

#define TMP_CST_VARS(i,x) @hidden c##i : CST(i);

#define CST_VARS                                \
        @vbox;                                  \
        REPEAT16(TMP_CST_VARS,t)                \
        @end;

#define TMP_STATE_VARS(i,x) @state s##i x;

#define STATE_VARS(x)                            \
        @vbox;                                   \
        REPEAT16(TMP_STATE_VARS,x)               \
        @end;


/* G function */

#define GFUN(r,i,a,b,c,d)		\
	@group STR(G##i);		\
	@vbox; 				\
	MSG0(r,i)                     	\
	@hidden a    = a + b;         	\
	@state  a    = a + tmp_m;     	\
	@state  d%16 = d ^ a;         	\
	@state  c    = c + d;	      	\
	@state  b%12 = b ^ c;         	\
	@end;	       	      		\
	@vbox;	       	      		\
	MSG1(r,i)                	\
	@hidden a    = a + b;         	\
	@state  a    = a + tmp_m;     	\
	@state  d%8  = d ^ a;         	\
	@state  c    = c + d;	      	\
	@state  b%7  = b ^ c;		\
	@end;	     	       		\
	@end;

/* Even half round */

#define ROUND0(i)				\
	@vbox;					\
	GFUN(i,0,S(0),S(4),S( 8),S(12))		\
	GFUN(i,1,S(1),S(5),S( 9),S(13))		\
	GFUN(i,2,S(2),S(6),S(10),S(14))		\
	GFUN(i,3,S(3),S(7),S(11),S(15))		\
	@end;

/* Odd half round */

#define ROUND1(i)				\
	@vbox;					\
	GFUN(i,4,S( 0),S( 5),S(10),S(15))	\
	GFUN(i,5,S( 1),S( 6),S(11),S(12))	\
	GFUN(i,6,S( 2),S( 7),S( 8),S(13))	\
	GFUN(i,7,S( 3),S( 4),S( 9),S(14))       \
	@end;

/* Full round */

#define ROUND(i)				\
	@hbox;					\
	ROUND0(i)				\
	ROUND1(i)				\
	@end;

/* Now you can use whatever part you're playing with */

#ifdef BOOMERANG
@conf boomerang = 1
@conf bskip = 16

@vbox;
#endif

@hbox;
CST_VARS
@end;

@hbox;
MSG_VARS(NODIFF)
STATE_VARS(NODIFF)
ROUND1(2)
ROUND(3)
ROUND(4)
ROUND0(5)
@end;

#ifdef BOOMERANG
@hbox;
MSG_VARS(NODIFF)
STATE_VARS(NODIFF)
ROUND1(2)
ROUND(3)
ROUND(4)
ROUND0(5)
@end;

@hbox;
MSG_VARS(NODIFF)
STATE_VARS()
ROUND1(2)
ROUND(3)
ROUND(4)
ROUND0(5)
@end;

@hbox;
MSG_VARS(NODIFF)
STATE_VARS()
ROUND1(2)
ROUND(3)
ROUND(4)
ROUND0(5)
@end;

@end;
#endif
