/* This file must be pre-processed by cpp */

#define NODIFF : --------------------------------

#include "has-160_cst.pp"

#ifdef USE_SUM4
// SUM4 avoids the need to specifiy intermediary sums
// but boomerang quartets cannot not be checked through SUM4
#define STEP(i,j,k,a,b,c,d,e)			\
	@state m NODIFF;			\
	@state f = HAS_F(i)(b,c,d);		\
	@state e = Sum4(e,a%HAS_ROTA(j,k),m,f);	\
	@state b = b%HAS_ROTB(i);
#else
#define STEP(i,j,k,a,b,c,d,e)			\
	@state m NODIFF;			\
	@state f = HAS_F(i)(b,c,d);		\
	@state e = e+a%HAS_ROTA(j,k);		\
	@state e = e+m;				\
	@state e = e+f;	\
	@state b = b%HAS_ROTB(i);
#endif

#define STEP5(i,j)				\
	STEP(i,j,0,a,b,c,d,e)			\
	STEP(i,j,1,e,a,b,c,d)			\
	STEP(i,j,2,d,e,a,b,c)			\
	STEP(i,j,3,c,d,e,a,b)			\
	STEP(i,j,4,b,c,d,e,a)			\

#define ROUND(i)				\
	STEP5(i,0)				\
	STEP5(i,1)				\
	STEP5(i,2)				\
	STEP5(i,3)				\

#define STATE_VARS                               \
        @vbox;                                   \
        @state a;                                \
        @state b;                                \
        @state c;                                \
        @state d;                                \
        @state e;                                \
        @end;

@conf wordsize = 32;
@conf linesize = 32;

@vbox;
STATE_VARS
//ROUND(0)
ROUND(1)
ROUND(2)
//ROUND(3)
@end;
