/* This file must be pre-processed by cpp */

#include "skein_cst.pp"

#define NODIFF : ----------------------------------------------------------------

#define STR(x) #x
#define M(i) m##i
#define S(i) s##i

#define MIXPERMUTE0(i)                          \
        @vbox;                                  \
        @state a1   = a0 + b0;                  \
        @state d1   = a1 ^ b0%R0(i);            \
        @state c1   = c0 + d0;                  \
        @state b1   = c1 ^ d0%R1(i);            \
        @end;

#define MIXPERMUTE1(i)                          \
        @vbox;                                  \
        @state a0   = a1 + b1;                  \
        @state d0   = a0 ^ b1%R0(i);            \
        @state c0   = c1 + d1;                  \
        @state b0   = c0 ^ d1%R1(i);            \
        @end;

#define ROUND_EVEN                              \
        MIXPERMUTE0(0)                          \
        MIXPERMUTE1(1)                          \
        MIXPERMUTE0(2)                          \
        MIXPERMUTE1(3)

#define ROUND_ODD                               \
        MIXPERMUTE0(4)                          \
        MIXPERMUTE1(5)                          \
        MIXPERMUTE0(6)                          \
        MIXPERMUTE1(7)

#define ADD_KEY(x)                              \
        @vbox;                                  \
        @state k0 x;                            \
        @state k1 x;                            \
        @state k2 x;                            \
        @state k3 x;                            \
        @end;                                   \
        @vbox;                                  \
        @state a0 = a0 + k0;                    \
        @state b0 = b0 + k1;                    \
        @state c0 = c0 + k2;                    \
        @state d0 = d0 + k3;                    \
        @end;


#define STATE_VARS(x)                            \
        @vbox;                                   \
        @state a0 x;                             \
        @state b0 x;                             \
        @state c0 x;                             \
        @state d0 x;                             \
        @end;

@conf wordsize = 64;
@conf linesize = 64;

@vbox;
STATE_VARS(NODIFF)
ROUND_EVEN
ADD_KEY(NODIFF)
ROUND_ODD
ADD_KEY(NODIFF)
ROUND_EVEN
@end;
