/* This file must be pre-processed by cpp */

#include "skein_cst_512.pp"

#define NODIFF : ----------------------------------------------------------------

#define STR(x) #x
#define M(i) m##i
#define S(i) s##i

#define MIXPERMUTE0(i)                          \
        @vbox;                                  \
        @state g1   = a0 + b0;                  \
        @state b1   = g1 ^ b0%R0(i);            \
        @state a1   = c0 + d0;                  \
        @state h1   = a1 ^ d0%R1(i);            \
        @state c1   = e0 + f0;                  \
        @state f1   = c1 ^ f0%R2(i);            \
        @state e1   = g0 + h0;                  \
        @state d1   = e1 ^ h0%R3(i);            \
        @end;

#define MIXPERMUTE1(i)                          \
        @vbox;                                  \
        @state g0   = a1 + b1;                  \
        @state b0   = g0 ^ b1%R0(i);            \
        @state a0   = c1 + d1;                  \
        @state h0   = a0 ^ d1%R1(i);            \
        @state c0   = e1 + f1;                  \
        @state f0   = c0 ^ f1%R2(i);            \
        @state e0   = g1 + h1;                  \
        @state d0   = e0 ^ h1%R3(i);            \
        @end;

#define ROUND_EVEN                              \
        @group "Even round";                    \
        @vbox;                                  \
        MIXPERMUTE0(0)                          \
        MIXPERMUTE1(1)                          \
        MIXPERMUTE0(2)                          \
        MIXPERMUTE1(3)                          \
        @end;                                   \
        @end;

#define ROUND_ODD                               \
        @group "Odd round";                     \
        @vbox;                                  \
        MIXPERMUTE0(4)                          \
        MIXPERMUTE1(5)                          \
        MIXPERMUTE0(6)                          \
        MIXPERMUTE1(7)                          \
        @end;                                   \
        @end;

#define ADD_KEY(x)                              \
        @vbox;                                  \
        @state k0 x;                            \
        @state k1 x;                            \
        @state k2 x;                            \
        @state k3 x;                            \
        @state k4 x;                            \
        @state k5 x;                            \
        @state k6 x;                            \
        @state k7 x;                            \
        @end;                                   \
        @vbox;                                  \
        @state a0 = a0 + k0;                    \
        @state b0 = b0 + k1;                    \
        @state c0 = c0 + k2;                    \
        @state d0 = d0 + k3;                    \
        @state e0 = e0 + k4;                    \
        @state f0 = f0 + k5;                    \
        @state g0 = g0 + k6;                    \
        @state h0 = h0 + k7;                    \
        @end;


#define STATE_VARS(x)                            \
        @vbox;                                   \
        @state a0 x;                             \
        @state b0 x;                             \
        @state c0 x;                             \
        @state d0 x;                             \
        @state e0 x;                             \
        @state f0 x;                             \
        @state g0 x;                             \
        @state h0 x;                             \
        @end;

@conf wordsize = 64;
@conf linesize = 64;
@conf boomerang = 1

@hbox;

@vbox;
STATE_VARS(NODIFF)
ROUND_ODD
ADD_KEY(NODIFF)
ROUND_EVEN
ADD_KEY(NODIFF)
ROUND_ODD
@end;

@vbox;
STATE_VARS(NODIFF)
ROUND_ODD
ADD_KEY(NODIFF)
ROUND_EVEN
ADD_KEY(NODIFF)
ROUND_ODD
@end;

@vbox;
STATE_VARS()
ROUND_ODD
ADD_KEY(NODIFF)
ROUND_EVEN
ADD_KEY(NODIFF)
ROUND_ODD
@end;

@vbox;
STATE_VARS()
ROUND_ODD
ADD_KEY(NODIFF)
ROUND_EVEN
ADD_KEY(NODIFF)
ROUND_ODD
@end;

@end;
